# Mathématique modulaire

- Soient \\(a, b \in \mathbb{Z}\\) avec \\(a \neq 0\\)
    - On dit que \\( a \\) **divise** \\( b \\) noté \\( a | b \\)
        - ssi \\( \exists c \in \mathbb{Z} b=ac \\)
        - On dit également que b est un multiple de a

## Algorithme de division d'euclide

- Soient \\( a \in \mathbb{Z} \text{ et } d\in \mathbb{N} _ 0 \\)
    - \\( \exists q, r \in \mathbb{Z} \quad 0 \leq r < d \quad a = dq + r\\)
\mathbb{R}

- Soient \\( a, b \in \mathbb{Z} \quad n \in \mathbb{N} _ 0  \\)
    - On dit que \\( a \\) est **congru** à \\( b \\) modulo n
        - ssi \\( n \vert (a - b) \\)
            - On note \\( a \equiv_n b \\) 

## La Cryptographie

Lorsqu'un cannal de communication n'est pas sur, il faut crypter les messages.
Le message passe par une fonction pour crypter et une autre fonction pour décrypter. c'est un chiffrement asymetrique

On se base sur les mathématiques modulaires pour crypter

### Les nombres premiers

- Soit \\( p \in \mathbb{N} \\) On dit que \\( P \\) est un **Nombre Premier**
    - ssi il posséde exactement 2 diviseurs 
        - Ces diviseurs sont \\( 1 \text{ et } P \\)  

Nous avons vu un algorithme nous permettant de voir si un nombre est premier TODO
